--  $Id: periodic_workloads.adb,v 1.3 2008/11/20 18:49:43 baker Exp baker $

package body Periodic_Workloads is

   procedure Bind_Parms (M : in out Object;
                         P : Parameters) is
   begin
      M.Parms := P;
   end Bind_Parms;

   procedure Arrive (M : in out Object;
                     T : in Time;
                     J : out Jobs.Job;
                     Next_Arrival_Time : out Time) is
   begin
      J.Arrival_Time := T;
      J.Execution_Time := M.Parms.WCET;
      J.Absolute_Deadline := T + M.Parms.Deadline;
      Next_Arrival_Time := T + M.Parms.Period;
   end Arrive;

   function Start_Time (M : in Object) return Time is
   begin
      return 0;
   end Start_Time;

   function Name (Model : Object) return String is
   begin
      return "periodic";
   end Name;

end Periodic_Workloads;
