--  $Id: replenishments.adb,v 1.2 2008/11/20 22:18:50 baker Exp baker $

with Error_Log; use Error_Log;
with Ada.Text_IO; use Ada.Text_IO;
package body Replenishments is

   function ">" (Left, Right: R_Info) return Boolean is
   begin
      return Left.R_Time >= Right.R_Time;
   end ">";

   procedure Check_R_Sum
      (Q : in out Queues.Object;
       Budget : in Time;
       Msg: String) is
      Total : Time := 0;
      procedure Check_One (R : R_Info) is
      begin
         Total := Total + R.R_Amount;
      end Check_One;
      procedure Check_All is new
        Queues.For_All (Check_One);
   begin
      Check_All (Q);
      pragma Assert (Total = Budget, Msg);
   end Check_R_Sum;

   procedure Show_R_Queue
      (Q : in Queues.Object;
       Msg: String;
       Threshold : Integer) is
      Total : Time := 0;
      procedure Show_One (R : R_Info) is
      begin
         Put (Log, '[' & Time'Image (R.R_Time)
                &  Time'Image (R.R_Amount) & ']');
      end Show_One;
      procedure Show_All is new
        Replenishments.Queues.For_All (Show_One);
   begin
      if Debug_Level > Threshold then
         Put (Log, ' ');
         Show_All (Q);
         Put_Line (Log, ' ' &  Msg);
      end if;
   end Show_R_Queue;

end Replenishments;

