--  $Id: threads-sched_dss.ads,v 1.2 2008/11/20 18:49:43 baker Exp baker $

-- deadline sporadic scheduler policy plug-in

with Replenishments;
with Aperiodic_Server_Parameters; use Aperiodic_Server_Parameters;
package Threads.Sched_Dss is

   type Object is new
     Threads.Scheduling_Policies.Object with private;

   procedure Bind_Parms
     (P : in out Object;
      Parms : Aperiodic_Server_Parameters.Parameters);
   procedure Init
     (P : in out Object);
   procedure New_Job
     (P : in out Object;
      J : in Jobs.Job);
   procedure Suspend
     (P : in out Object);
   procedure Unsuspend
     (P : Object);
   procedure New_Current_Thread
     (P : Object);
   procedure Go
     (P : in out Object);
   procedure Stop
     (P : in out Object);

private

   package Replenishment_Events is
      type Object is new Events.Object with record
         T : Thread_Ref;
      end record;
      procedure Handler (E : in out Object);
      function Name (E : Object) return String;
   end Replenishment_Events;

   package Budget_Exhaustion_Events is
      type Object is new Events.Object with record
         T : Thread_Ref;
      end record;
      procedure Handler (E : in out Object);
      function Name (E : Object) return String;
   end Budget_Exhaustion_Events;

   type Object is new
     Threads.Scheduling_Policies.Object with record
     Parms : Aperiodic_Server_Parameters.Parameters;
     R_Queue : Replenishments.Queues.Object;
     Replenishment : aliased Replenishment_Events.Object;
     Exhaustion: aliased Budget_Exhaustion_Events.Object;
     Current_Job : Jobs.Job;
   end record;

end Threads.Sched_Dss;
